--[[
This lua script draws two rectangles and several words. One rectangle is used as the selected frame, another is the backgroud of the words. Each word selects from the words_table. In this script, the option to choose from the table is the "time %H". The words will be displayed in order. The selected word can be showed in different font options (like color, alpha and so on).
This script is fully customisable, all the functions can be changed by special need.
Changelog:
designed by putputput (14.12.2010v0.1)
]]

words_table = {
  {
    word='子',
    color=0xffffff
  },
  {    
    word='丑',
    color=0xffffff
  },
  {
    word='寅',
    color=0xffffff
  },
  {
    word='卯',
    color=0xffffff
  },
  {
    word='辰',
    color=0xffffff
  },
  {    
    word='巳',
    color=0xffffff
  },
  {
    word='午',
    color=0xffffff
  },
  {
    word='未',
    color=0xffffff
  },
  {
    word='申',
    color=0xffffff
  },
  {
    word='酉',
    color=0xffffff
  },
  {
    word='戌',
    color=0xffffff
  },
  {
    word='亥',
    color=0xffffff
  },
}
require 'cairo'
function conky_t_list()
--以下定义时辰与24时制的转换
  local i=1
  if hours_24==23 or hours_24==0 then
    i=1
  elseif hours_24==1 or hours_24==2 then
    i=2
  elseif hours_24==3 or hours_24==4 then
    i=3
  elseif hours_24==5 or hours_24==6 then
    i=4
  elseif hours_24==7 or hours_24==8 then
    i=5
  elseif hours_24==9 or hours_24==10 then
    i=6
  elseif hours_24==11 or hours_24==12 then
    i=7
  elseif hours_24==13 or hours_24==14 then
    i=8
  elseif hours_24==15 or hours_24==16 then
    i=9
  elseif hours_24==17 or hours_24==18 then
    i=10
  elseif hours_24==19 or hours_24==20 then
    i=11
  else
    i=12
  end
--初始化cairo环境  
  if conky_window==nil then return end

  local w,h=conky_window.width,conky_window.height
  local cs=cairo_xlib_surface_create(conky_window.display,conky_window.drawable,conky_window.visual, conky_window.width,conky_window.height)
  local cr=cairo_create(cs)   
   
--半透明bar
  space_bar(cr,29,410,22,120,0.2,0.5,1,0,0.2,0.5,1,0,0.5)	--竖bar
  space_bar(cr,10,469,60,20,1,1,1,0.5,1,1,1,0.4,0.2) 		--横bar
--  space_bar(cr,hx1,hy1,hx2,hy2,0.2,0.5,1,0,0.2,0.5,1,0,0.5)	--竖bar
--  space_bar(cr,sx3,sy3,sx4,sy4,1,1,1,0.5,1,1,1,0.4,0.2) 	--横bar

--文字滚动部分
  hours_24=tonumber(conky_parse('${time %H}'))
--显示时辰
  show_word(cr,32,485,hours_24,0.5,1,words_table[i],i)
end

--以下为绘制半透明bar函数（对象，起始点x，起始点y，终点x，终点y，边框颜色及透明度（4变量），填充内容（颜色（3变量），上下边沿透明度，中部透明度））
function space_bar(cr,cx,cy,dx,dy,r,g,b,a,ir,ig,ib,ia,ea)
  local x1,y1,x2,y2,r1,g1,b1,a1,ir1,ig1,ib1,ia1,ea1=cx,cy,dx,dy,r,g,b,a,ir,ig,ib,ia,ea
  pat3 = cairo_pattern_create_linear (x1,y1,x1,y1+y2)
  cairo_pattern_add_color_stop_rgba (pat3,0,ir1,ig1,ib1,ia1);
  cairo_pattern_add_color_stop_rgba (pat3,0.6,ir1,ig1,ib1,ea1);
  cairo_pattern_add_color_stop_rgba (pat3,0.9,ir1,ig1,ib1,ia1);
  cairo_set_source_rgba(cr, r1,g1,b1,a1)
  cairo_rectangle(cr, x1, y1,x2,y2)
  cairo_stroke_preserve(cr)
  --cairo_set_source_rgba(cr, ir1,ig1,ib1,ia1)
  cairo_set_source (cr, pat3)
  cairo_fill(cr)
  --cairo_destroy(cr)
end
--绘制文字部分函数（对象，起始点x，起始点y，24时制时间，未选中透明度，选中透明度，时辰数组，选择数组项）
function show_word(cr,cx,cy,hours_24,a1,a2,pt,i)
--重点显示选中字
  local word,color=pt['word'],pt['color']

  cairo_set_source_rgba(cr,rgb_to_r_g_b(color,a2)) 
  cairo_select_font_face(cr, "WenQuanYi Zen Hei",
      CAIRO_FONT_SLANT_NORMAL,
      CAIRO_FONT_WEIGHT_BOLD)
  cairo_set_font_size(cr, 16)
  cairo_move_to(cr, cx, cy)
  cairo_text_path(cr,word)
  --cairo_set_line_width(cr,0.5)
  cairo_fill(cr)

--显示其他字
  local count_dis1=1
  local count_dis2=1
  for j in pairs(words_table) do
    if (i-j)<=3 and (i-j)>0 then
      show_other_words(cr,cx,cy,a1,words_table[j],i,j)
    
    elseif (i-j)>=-2 and (i-j)<0 then
      show_other_words(cr,cx,cy,a1,words_table[j],i,j)

    end
      if i<=3 and count_dis1==1 then
	for k=1,(4-i) do
	  show_other_words(cr,cx,cy,a1,words_table[13-k],12+i,13-k)  	  
	  count_dis1=2
	end
	
      end
      if i>=11 and count_dis2==1 then
	for k=1,(i-10) do
	  show_other_words(cr,cx,cy,a1,words_table[k],i-12,k)  	  
	  count_dis2=2
	end
      end
  end
  
  cairo_stroke(cr)
end

function rgb_to_r_g_b(colour,alpha)
    return ((colour / 0x10000) % 0x100) / 255., ((colour / 0x100) % 0x100) / 255., (colour % 0x100) / 255., alpha
end
--显示未选中部分文字的子函数（对象，起始点x，起始点y，透明度，时辰数组，当前选中项，未选中项）
function show_other_words(cr,cx,cy,a1,pt,i,j)
  local word,color=pt['word'],pt['color']
  local sp_w=j-i
  
  cairo_set_source_rgba(cr,rgb_to_r_g_b(color,a1)) 
  cairo_select_font_face(cr, "WenQuanYi Zen Hei",
      CAIRO_FONT_SLANT_NORMAL,
      CAIRO_FONT_WEIGHT_NORMAL)
  cairo_set_font_size(cr, 16)
  cairo_move_to(cr, cx, cy+sp_w*20)
  cairo_text_path(cr,word)
  cairo_fill(cr)

end
